

%header

tol=0.005;
theta=0.001;

[lnc,Tc,Tic]=tauchen(0,sigma_c,Nc);
lnc=lnc+mu_c;
cf=exp(lnc)';
ce=sum(Tic.*cf);    %Set entry cost to mean operating cost
ce=2.95*ce;     %In baseline, factor of 2.95 targets startup rate=0.09.



%% Scenarios


Avec=[1 1.2];


wvec=[3.8 4];

iter=1
for iA=1:length(Avec)
 
    A=Avec(iA);                    %Aggregate state

    
    Me=1500;
    Melo=0;
    Mehi=2500;
    
    
    egap=100;
    eiter=1;
    while abs(egap)>tol%Entry rate iteration
        
        %% Clear labor market
        %w=3;
        w=wvec(iA);
        wlo=2;
        whi=6;
        
        lgap=100;
        
        fprintf('lgap=100');
        %     wlo=wlovec(iA);
        %     whi=whivec(iA);
        %w=wvec(iA);
        
        
        
        witer=1;
        while lgap>tol
            [measure,entryrate,aggemp,entryemp,noexit,EV]=geneqm2(A,w,Me,gamma,alpha,ce,1,iter);
            %A,w,gamma,alpha,ce,save mu/vfi etc,iteration
            
            lgap=abs(log(aggemp)-log(w^gamma));
            
            impliedwage=aggemp^(1/gamma);
            
            %lgap=0.5*tol; %Partial equilibrium
            [w,log(aggemp)-log(w^gamma),Me/100,egap]
            if lgap>tol || noexit==1
                if noexit==0
                    if aggemp>w^gamma %demand exceeds supply, raise the wage
                        wlo=w;
                        w=w+(whi-w)/2;
                        
                    else %Supply exceeds demand, reduce the wage
                        whi=w;
                        w=w-(w-wlo)/2;
                    end
                    %w=theta*impliedwage+(1-theta)*w;
                elseif noexit>0
                    wlo=w;
                    w=w+(whi-w)/2;
                    
                    fprintf('No EXITS!')
                else
                    fprintf('WE GOT NOTHIN')
                end
            end
            
            
            if mod(witer,5)==0
                fprintf('...%s',lgap)
            end
            
            witer=witer+1;
            
        end%Wage iteration
        
        
        egap=log(ce)-log(EV);
        
        if abs(egap)>tol
            if EV>ce%More room for entry
                Melo=Me;
                Me=Me+(Mehi-Me)/2;
            else
                Mehi=Me;
                Me=Me-(Me-Melo)/2;
            end
        end
        
        
        
        
    end%entry iteration
    
        

        

        
  
    

    
    temp=[A w alpha measure entryrate aggemp entryemp entryemp/aggemp];
    if iter==1
        outfile=temp;
        save('outfile.mat','outfile');
    else
        load('outfile.mat')
        outfile=[outfile;temp];
        save('outfile.mat','outfile');
    end
    csvwrite('outfile.csv',outfile);
    
    iter=iter+1
end


entryrate
measure
w

    
    
    
    
    
    
    