clc
clear
close all
%% Housekeeping
global Nz Nc beta xi M rho_z sigma_z mu_c sigma_c 

Nz=500;                  %Idio TFP points
Nc=25;                 %Stochastic fixed cost points

beta=0.96;              %Discount factor
alpha=0.8;              %Curvature
gamma=2;                %Labor supply elasticity
M=500;                    %Entrant measure

rho_z=0.55;             %Idio TFP persistence
sigma_z=0.22;           %Idio TFP dispersion

mu_c=-6.7;              %Fixed cost mean
sigma_c=0.9;            %Fixed cost dispersion

xi=2.69;                   %Pareto shape parameter for potential entrants